import collections

def solve():
    n, m, k = map(int, input().split())
    edges = []
    for _ in range(m):
        u, v = map(int, input().split())
        edges.append((u, v))
        edges.append((v, u))  # Undirected graph

    guards = []
    for _ in range(k):
        p, h = map(int, input().split())
        guards.append((p, h))

    def bfs(start_node, graph):
        queue = collections.deque([(start_node, 0)])
        visited = {start_node}
        distances = {}
        distances[start_node] = 0
        while queue:
            node, dist = queue.popleft()
            for neighbor in graph.get(node, []):
                if neighbor not in visited:
                    visited.add(neighbor)
                    distances[neighbor] = dist + 1
                    queue.append((neighbor, dist + 1))
        return distances

    graph = collections.defaultdict(list)
    for u, v in edges:
        graph[u].append(v)

    protected_warehouses = set()
    for guard_pos, guard_range in guards:
        distances = bfs(guard_pos, graph)
        for warehouse, dist in distances.items():
            if dist <= guard_range:
                protected_warehouses.add(warehouse)

    protected_warehouses = sorted(list(protected_warehouses))
    print(len(protected_warehouses))
    print(*protected_warehouses) if protected_warehouses else print()

solve()
